package org.openoffice;

import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.XPropertySet;
import com.sun.star.container.XNameAccess;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.lib.uno.helper.WeakBase;
import com.sun.star.uno.AnyConverter;
import com.sun.star.util.XChangesBatch;
import javax.swing.JOptionPane;


public final class AddonsReinstallationBug extends WeakBase
   implements com.sun.star.lang.XServiceInfo,
              com.sun.star.frame.XDispatchProvider,
              com.sun.star.lang.XInitialization,
              com.sun.star.frame.XDispatch
{
    private final XComponentContext m_xContext;
    private com.sun.star.frame.XFrame m_xFrame;
    private XMultiServiceFactory m_xConfigurationProvider;

    
    private static final String m_implementationName = AddonsReinstallationBug.class.getName();
    private static final String[] m_serviceNames = {
        "com.sun.star.frame.ProtocolHandler" };


    public AddonsReinstallationBug( XComponentContext context )
    {
        m_xContext = context;
    };

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;

        if ( sImplementationName.equals( m_implementationName ) )
            xFactory = Factory.createComponentFactory(AddonsReinstallationBug.class, m_serviceNames);
        return xFactory;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(m_implementationName,
                                                m_serviceNames,
                                                xRegistryKey);
    }

    // com.sun.star.lang.XServiceInfo:
    public String getImplementationName() {
         return m_implementationName;
    }

    public boolean supportsService( String sService ) {
        int len = m_serviceNames.length;

        for( int i=0; i < len; i++) {
            if (sService.equals(m_serviceNames[i]))
                return true;
        }
        return false;
    }

    public String[] getSupportedServiceNames() {
        return m_serviceNames;
    }

    // com.sun.star.frame.XDispatchProvider:
    public com.sun.star.frame.XDispatch queryDispatch( com.sun.star.util.URL aURL,
                                                       String sTargetFrameName,
                                                       int iSearchFlags )
    {
        if ( aURL.Protocol.compareTo("org.openoffice.addonsreinstallationbug:") == 0 )
        {
            if ( aURL.Path.compareTo("Command0") == 0 )
                return this;
        }
        return null;
    }

    // com.sun.star.frame.XDispatchProvider:
    public com.sun.star.frame.XDispatch[] queryDispatches(
         com.sun.star.frame.DispatchDescriptor[] seqDescriptors )
    {
        int nCount = seqDescriptors.length;
        com.sun.star.frame.XDispatch[] seqDispatcher =
            new com.sun.star.frame.XDispatch[seqDescriptors.length];

        for( int i=0; i < nCount; ++i )
        {
            seqDispatcher[i] = queryDispatch(seqDescriptors[i].FeatureURL,
                                             seqDescriptors[i].FrameName,
                                             seqDescriptors[i].SearchFlags );
        }
        return seqDispatcher;
    }

    // com.sun.star.lang.XInitialization:
    public void initialize( Object[] object )
        throws com.sun.star.uno.Exception
    {
        if ( object.length > 0 )
        {
            m_xFrame = (com.sun.star.frame.XFrame)UnoRuntime.queryInterface(
                com.sun.star.frame.XFrame.class, object[0]);
            GetConfigurationProvider();
        }
    }

    // com.sun.star.frame.XDispatch:
     public void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments )
    {
         if ( aURL.Protocol.compareTo("org.openoffice.addonsreinstallationbug:") == 0 )
        {
            if ( aURL.Path.compareTo("Command0") == 0 )
            {
                ReadConfigValueAndWriteNew( "TestValue" );
                ReadConfigValueAndWriteNew( "AddedTestValue" );
                return;
            }
        }
    }

    public void addStatusListener( com.sun.star.frame.XStatusListener xControl,
                                    com.sun.star.util.URL aURL )
    {
        // add your own code here
    }

    public void removeStatusListener( com.sun.star.frame.XStatusListener xControl,
                                       com.sun.star.util.URL aURL )
    {
        // add your own code here
    }

    protected static XMultiServiceFactory GetConfigurationProvider( XComponentContext xContext )
        throws com.sun.star.uno.Exception
    {
        XMultiServiceFactory xConfigurationProvider = null;
        if ( xContext != null )
        {
            XMultiComponentFactory xFactory = xContext.getServiceManager();
            Object oConfigProvider = xFactory.createInstanceWithContext( "com.sun.star.configuration.ConfigurationProvider", xContext );
            xConfigurationProvider = ( XMultiServiceFactory ) UnoRuntime.queryInterface( XMultiServiceFactory.class, oConfigProvider );
        }

        if ( xConfigurationProvider == null )
            throw new com.sun.star.uno.RuntimeException();
        
        return xConfigurationProvider;
    }

    protected XMultiServiceFactory GetConfigurationProvider()
        throws com.sun.star.uno.Exception
    {
        if ( m_xConfigurationProvider == null )
            m_xConfigurationProvider = GetConfigurationProvider( m_xContext );

        if ( m_xConfigurationProvider == null )
            throw new com.sun.star.uno.RuntimeException();

        return m_xConfigurationProvider;
    }

    static private XPropertySet GetConfigPropertySet( XComponentContext xContext )
        throws com.sun.star.uno.Exception
    {
        PropertyValue aVal = new PropertyValue();
        aVal.Name = "nodepath";
        aVal.Value = "/org.openoffice.Office.Custom.AddonsReinstallationBug/Persistence";
        Object[] aArgs = new Object[1];
        aArgs[0] = aVal;
        
        Object oSettings = GetConfigurationProvider( xContext ).createInstanceWithArguments(
                                    "com.sun.star.configuration.ConfigurationUpdateAccess",
                                    aArgs );
        XPropertySet xProps = ( XPropertySet ) UnoRuntime.queryInterface( XPropertySet.class, oSettings );
        if ( xProps == null )
            throw new com.sun.star.uno.RuntimeException();
        
        return xProps;
    }
 
    private XNameAccess GetConfigNameAccess()
        throws com.sun.star.uno.Exception
    {
        PropertyValue aVal = new PropertyValue();
        aVal.Name = "nodepath";
        aVal.Value = "/org.openoffice.Office.Custom.AddonsReinstallationBug/Persistence";
        Object[] aArgs = new Object[1];
        aArgs[0] = aVal;

        Object oSettings = GetConfigurationProvider().createInstanceWithArguments(
                                    "com.sun.star.configuration.ConfigurationAccess",
                                    aArgs );
        XNameAccess xNameAccess = ( XNameAccess ) UnoRuntime.queryInterface( XNameAccess.class, oSettings );
        if ( xNameAccess == null )
            throw new com.sun.star.uno.RuntimeException();
        
        return xNameAccess;
    }

    protected void ReadConfigValueAndWriteNew( String aName )
    {
        try
        {
            XNameAccess xSets = GetConfigNameAccess();
            int nResult = AnyConverter.toInt( xSets.getByName( aName ) );
            int nNewResult = ( nResult + 1 ) % 10;
            
            XPropertySet xProps = GetConfigPropertySet( m_xContext );
            xProps.setPropertyValue( aName, new Integer( nNewResult ) );
            XChangesBatch xToCommit = ( XChangesBatch ) UnoRuntime.queryInterface( XChangesBatch.class, xProps );
            if ( xToCommit != null )
                xToCommit.commitChanges();
            
            JOptionPane.showMessageDialog( null, aName + ":\nThe old value is " + nResult + "\nThe new value is " + nNewResult );
        }
        catch( java.lang.Exception e )
        {
            JOptionPane.showMessageDialog( null, e );
        }
    }
}
